## mender-client 1.7.0

=== Makefile ===
GO ?= go
GOFMT ?= gofmt
V ?=
PKGS = $(shell go list ./... | grep -v vendor)
PKGFILES = $(shell find . \( -path ./vendor -o -path ./Godeps \) -prune \
		-o -type f -name '*.go' -print)
PKGFILES_notest = $(shell echo $(PKGFILES) | tr ' ' '\n' | grep -v _test.go)
GOCYCLO ?= 15

CGO_ENABLED=1
export CGO_ENABLED

TOOLS = \
	github.com/fzipp/gocyclo \
	github.com/opennota/check/cmd/varcheck \
	github.com/mendersoftware/deadcode

VERSION = $(shell git describe --tags --dirty --exact-match 2>/dev/null || git rev-parse --short HEAD)

GO_LDFLAGS = \
	-ldflags "-X main.Version=$(VERSION)"

ifeq ($(V),1)
BUILDV = -v
endif

TAGS =
ifeq ($(LOCAL),1)
TAGS += local
endif

ifneq ($(TAGS),)
BUILDTAGS = -tags '$(TAGS)'
endif

build:
	$(GO) build $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS)

install:
	$(GO) install $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS)

clean:
	$(GO) clean
	rm -f coverage.txt coverage-tmp.txt

get-tools:
	set -e ; for t in $(TOOLS); do \
		echo "-- go getting $$t"; \
		go get -u $$t; \
	done

check: test extracheck

test:
	$(GO) test $(BUILDV) $(PKGS)

extracheck:
	echo "-- checking if code is gofmt'ed"
	if [ -n "$$($(GOFMT) -d $(PKGFILES))" ]; then \
		"$$($(GOFMT) -d $(PKGFILES))" \
		echo "-- gofmt check failed"; \
		/bin/false; \
	fi
	echo "-- checking with govet"
	$(GO) tool vet -unsafeptr=false $(PKGFILES_notest)
	echo "-- checking for dead code"
	deadcode -ignore version.go:Version
	echo "-- checking with varcheck"
	varcheck .
	echo "-- checking cyclometric complexity > $(GOCYCLO)"
	gocyclo -over $(GOCYCLO) $(PKGFILES_notest)

cover: coverage
	$(GO) tool cover -func=coverage.txt

htmlcover: coverage
	$(GO) tool cover -html=coverage.txt

coverage:
	rm -f coverage.txt
	echo 'mode: set' > coverage.txt
	set -e ; for p in $(PKGS); do \
		rm -f coverage-tmp.txt;  \
		$(GO) test -coverprofile=coverage-tmp.txt $$p ; \
		if [ -f coverage-tmp.txt ]; then \
			cat coverage-tmp.txt |grep -v 'mode:' >> coverage.txt; \
		fi; \
	done
	rm -f coverage-tmp.txt

.PHONY: build clean get-tools test check \
	cover htmlcover coverage

=== debian/changelog ===
mender-client (1.7.0-4) unstable; urgency=medium

  * Fix 'mender -version' output

 -- Andreas Henriksson <andreas@fatal.se>  Fri, 01 Feb 2019 15:08:36 +0100

mender-client (1.7.0-3) unstable; urgency=medium

  * Describe identity and inventory in README.Debian
  * Ship mender.conf.example in documentation directory
  * Mention mender.conf in README.Debian
  * Create directories for mender-device-identity and mender-inventory-*
  * Create directory for mender.conf transient settings
  * Improve README.Debian further

 -- Andreas Henriksson <andreas@fatal.se>  Tue, 22 Jan 2019 13:00:31 +0100

mender-client (1.7.0-2) experimental; urgency=medium

  * Disable DH_GOLANG_EXCLUDES{_ALL}
  * Add debian/patches to fix deploy_log_hook.go
  * Make tests non-fatal for now

 -- Andreas Henriksson <andreas@fatal.se>  Thu, 10 Jan 2019 17:12:59 +0100

mender-client (1.7.0-1) experimental; urgency=medium

  * New upstream version 1.7.0

 -- Andreas Henriksson <andreas@fatal.se>  Sat, 15 Dec 2018 15:34:45 +0100

mender-client (1.6.0b1+git20181015.3032b74-1) experimental; urgency=medium

  * Initial release (Closes: #914119)

 -- Andreas Henriksson <andreas@fatal.se>  Mon, 19 Nov 2018 18:34:58 +0100

=== debian/control ===
Source: mender-client
Section: devel
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Andreas Henriksson <andreas@fatal.se>
Build-Depends: debhelper (>= 11),
               dh-golang,
               golang-any,
               golang-github-pkg-errors-dev,
               golang-github-stretchr-testify-dev,
               golang-golang-x-net-dev,
               golang-golang-x-sys-dev,
               golang-logrus-dev,
	       golang-github-bmatsuo-lmdb-go-dev,
	       golang-github-ungerik-go-sysfs-dev,
	       golang-github-mendersoftware-mender-artifact-dev,
	       golang-github-mendersoftware-log-dev,
	       golang-github-mendersoftware-mendertesting-dev,
               ca-certificates <!nocheck>
Standards-Version: 4.2.1
Homepage: https://github.com/mendersoftware/mender
Vcs-Browser: https://salsa.debian.org/go-team/packages/mender-client
Vcs-Git: https://salsa.debian.org/go-team/packages/mender-client.git
XS-Go-Import-Path: github.com/mendersoftware/mender
Testsuite: autopkgtest-pkg-go

Package: mender-client
Architecture: any
Built-Using: ${misc:Built-Using}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: ca-certificates, u-boot-tools, mount, procps, systemd-sysv
Description: Mender over-the-air software updater client.
 Mender: over-the-air updater for embedded Linux devices
 .
 Mender is an open source over-the-air (OTA) software updater for embedded
 Linux devices. Mender comprises a client running at the embedded device, as
 well as a server that manages deployments across many devices.
 .
 Embedded product teams often end up creating homegrown updaters
 at the last minute due to the need to fix bugs in field-deployed
 devices. However, the most important requirement for an embedded update
 process is robustness, for example loss of power at any time should not
 brick a device. This creates a challenge given the time constraints to
 develop and maintain a homegrown updater.
 .
 Mender aims to address this challenge with a robust and easy to use
 updater for embedded Linux devices, which is open source and available
 to anyone.
 .
 Robustness is ensured with atomic image-based deployments using a dual
 A/B rootfs partition layout. This makes it always possible to roll
 back to a working state, even when losing power at any time during the
 update process.
 .
 Ease of use is addressed with an intuitive UI, comprehensive documentation
 (https://docs.mender.io/), a meta layer for the Yocto Project
 (https://github.com/mendersoftware/meta-mender) for easy integration
 into existing environments, and high quality software (see the test
 coverage badge).
 .
 This repository contains the Mender client updater, which can be run in
 standalone mode (manually triggered through its command line interface)
 or managed mode (connected to the Mender server).
 .
 Mender not only provides the client-side updater, but also the backend and
 UI for managing deployments as open source. The Mender server is designed
 as a microservices architecture and comprises several repositories.
 .
 To start using Mender, we recommend that you begin with the Getting
 started section in the Mender documentation (https://docs.mender.io/).
 .
 In order to support rollback, the Mender client depends on integration
 with U-Boot and the partition layout. It is therefore most easily
 built as part of your Yocto Project image by using the meta layer for
 the Yocto Project (https://github.com/mendersoftware/meta-mender).

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DH_GOLANG_INSTALL_EXTRA := client/server.crt \
	client/server.expired.crt \
	client/server.unknown-authority.crt
#export DH_GOLANG_EXCLUDES := github.com/mendersoftware/mender$
#export DH_GOLANG_EXCLUDES_ALL := 0

override_dh_auto_install:
	dh_auto_install -- --no-source

%:
	dh $@ --buildsystem=golang --with=golang

override_dh_auto_build:
	dh_auto_build -O--buildsystem=golang -- \
		-ldflags "-X main.Version=$(DEB_VERSION)"

override_dh_auto_test:
	dh_auto_test || true

## mender-client 2.0.1

=== debian/changelog ===
mender-client (2.0.1-1) unstable; urgency=medium

  [ Lluis Campos ]
  * Add patch for skipping TestLicense unit test
  * Add patch for fixing TestDeviceVerifyReboot unit test
  * Copy missing helper files and enable unit tests suite
  * Add identity and inventory scripts as examples in the package
  * Add the modules directory onto the list of dirs
  * Update Debian README to introduce Mender 2.0 changes
  * Add Lluis in debian/control Uploaders list

  [ Andreas Henriksson ]
  * New upstream version 2.0.1
  * Bump mender-artifact build-dep to avoid 3.0.0+really2.4.0-1
  * Make tests non-fatal again

 -- Andreas Henriksson <andreas@fatal.se>  Tue, 09 Jul 2019 17:55:27 +0200

mender-client (2.0.0-1) experimental; urgency=medium

  * New upstream version 2.0.0
  * Bump mender-artifact build-dep to >= 3
  * mender.conf.example is now mender.conf.{demo,production}
  * Bump years in debian/copyright

 -- Andreas Henriksson <andreas@fatal.se>  Fri, 17 May 2019 19:17:53 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: devel
 Priority: optional
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
-Uploaders: Andreas Henriksson <andreas@fatal.se>
+Uploaders: Andreas Henriksson <andreas@fatal.se>, Lluis Campos <lluis.campos@northern.tech>
 Build-Depends: debhelper (>= 11),
                dh-golang,
                golang-any,
@@ -13,7 +13,7 @@
                golang-logrus-dev,
 	       golang-github-bmatsuo-lmdb-go-dev,
 	       golang-github-ungerik-go-sysfs-dev,
-	       golang-github-mendersoftware-mender-artifact-dev,
+	       golang-github-mendersoftware-mender-artifact-dev (>= 3.0.1),
 	       golang-github-mendersoftware-log-dev,
 	       golang-github-mendersoftware-mendertesting-dev,
                ca-certificates <!nocheck>

## mender-client 2.1.0

=== debian/changelog ===
mender-client (2.1.0-2) unstable; urgency=medium

  * Add d/p/0002-Use-UBI_IOCVOLUP-from-golang.org-x-sys-unix-package.patch
    - this should fix FTBFS on mips64el and s390x

 -- Andreas Henriksson <andreas@fatal.se>  Fri, 20 Sep 2019 18:21:58 +0200

mender-client (2.1.0-1) unstable; urgency=medium

  [ Lluis Campos ]
  * New upstream version 2.1.0
  * Drop old patches, all changes merged now upstream
  * Bump mender-artifact-dev dependency version to 3.1.x

 -- Lluis Campos <lluis.campos@northern.tech>  Wed, 18 Sep 2019 15:55:34 +0200

## mender-client 2.1.2

=== Makefile ===
--- 
+++ 
@@ -1,3 +1,10 @@
+DESTDIR ?= /
+prefix ?= $(DESTDIR)
+bindir=/usr/bin
+datadir ?= /usr/share
+sysconfdir ?= /etc
+systemd_unitdir ?= /lib/systemd
+
 GO ?= go
 GOFMT ?= gofmt
 V ?=
@@ -33,15 +40,118 @@
 BUILDTAGS = -tags '$(TAGS)'
 endif
 
-build:
+IDENTITY_SCRIPTS = \
+	support/mender-device-identity
+
+INVENTORY_SCRIPTS = \
+	support/mender-inventory-bootloader-integration \
+	support/mender-inventory-hostinfo \
+	support/mender-inventory-network \
+	support/mender-inventory-os \
+	support/mender-inventory-rootfs-type
+
+MODULES = \
+	support/modules/deb \
+	support/modules/docker \
+	support/modules/directory \
+	support/modules/single-file \
+	support/modules/rpm \
+	support/modules/script
+
+MODULES_ARTIFACT_GENERATORS = \
+	support/modules-artifact-gen/docker-artifact-gen \
+	support/modules-artifact-gen/directory-artifact-gen \
+	support/modules-artifact-gen/single-file-artifact-gen
+
+build: mender
+
+mender: $(PKGFILES)
 	$(GO) build $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS)
 
-install:
-	$(GO) install $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS)
+install: install-bin install-conf install-identity-scripts install-inventory-scripts install-modules install-systemd
+
+install-bin: mender
+	install -m 755 -d $(prefix)$(bindir)
+	install -m 755 mender $(prefix)$(bindir)/
+
+install-conf:
+	install -m 755 -d $(prefix)$(sysconfdir)/mender
+	install -m 644 mender.conf.production $(prefix)$(sysconfdir)/mender/mender.conf.production
+	install -m 644 mender.conf.production $(prefix)$(sysconfdir)/mender/mender.conf
+	install -m 644 mender.conf.demo $(prefix)$(sysconfdir)/mender/mender.conf.demo
+	echo "artifact_name=unknown" > $(prefix)$(sysconfdir)/mender/artifact_info
+
+install-datadir:
+	install -m 755 -d $(prefix)$(datadir)/mender
+
+install-identity-scripts: install-datadir
+	install -m 755 -d $(prefix)$(datadir)/mender/identity
+	install -m 755 $(IDENTITY_SCRIPTS) $(prefix)$(datadir)/mender/identity/
+
+install-inventory-scripts: install-datadir
+	install -m 755 -d $(prefix)$(datadir)/mender/inventory
+	install -m 755 $(INVENTORY_SCRIPTS) $(prefix)$(datadir)/mender/inventory/
+
+install-modules:
+	install -m 755 -d $(prefix)$(datadir)/mender/modules/v3
+	install -m 755 $(MODULES) $(prefix)$(datadir)/mender/modules/v3/
+
+install-modules-gen:
+	install -m 755 -d $(prefix)$(bindir)
+	install -m 755 $(MODULES_ARTIFACT_GENERATORS) $(prefix)$(bindir)/
+
+install-systemd:
+	install -m 755 -d $(prefix)$(systemd_unitdir)/system
+	install -m 0644 support/mender.service $(prefix)$(systemd_unitdir)/system/
+
+install-demo: install
+	install -m 755 mender.conf.demo $(prefix)$(sysconfdir)/mender/mender.conf
+
+uninstall: uninstall-bin uninstall-conf uninstall-identity-scripts uninstall-inventory-scripts \
+	uninstall-modules uninstall-modules-gen uninstall-systemd
+
+uninstall-bin:
+	rm -f $(prefix)$(bindir)/mender
+	-rmdir -p $(prefix)$(bindir)
+
+uninstall-conf:
+	rm -f $(prefix)$(sysconfdir)/mender/mender.conf
+	rm -f $(prefix)$(sysconfdir)/mender/mender.conf.production
+	rm -f $(prefix)$(sysconfdir)/mender/mender.conf.demo
+	rm -f $(prefix)$(sysconfdir)/mender/artifact_info
+	-rmdir -p $(prefix)$(sysconfdir)/mender
+
+uninstall-identity-scripts:
+	for script in $(IDENTITY_SCRIPTS); do \
+		rm -f $(prefix)$(datadir)/mender/identity/$$(basename $$script); \
+	done
+	-rmdir -p $(prefix)$(datadir)/mender/identity
+
+uninstall-inventory-scripts:
+	for script in $(INVENTORY_SCRIPTS); do \
+		rm -f $(prefix)$(datadir)/mender/inventory/$$(basename $$script); \
+	done
+	-rmdir -p $(prefix)$(datadir)/mender/inventory
+
+uninstall-modules:
+	for script in $(MODULES); do \
+		rm -f $(prefix)$(datadir)/mender/modules/v3/$$(basename $$script); \
+	done
+	-rmdir -p $(prefix)$(datadir)/mender/modules/v3
+
+uninstall-modules-gen:
+	for script in $(MODULES_ARTIFACT_GENERATORS); do \
+		rm -f $(prefix)$(bindir)/$$(basename $$script); \
+	done
+	-rmdir -p $(prefix)$(bindir)
+
+uninstall-systemd:
+	rm -f $(prefix)$(systemd_unitdir)/system/mender.service
+	-rmdir -p $(prefix)$(systemd_unitdir)/system
 
 clean:
 	$(GO) clean
-	rm -f coverage.txt coverage-tmp.txt
+	rm -f coverage.txt
 
 get-tools:
 	set -e ; for t in $(TOOLS); do \
@@ -78,15 +188,18 @@
 
 coverage:
 	rm -f coverage.txt
-	echo 'mode: set' > coverage.txt
-	set -e ; for p in $(PKGS); do \
-		rm -f coverage-tmp.txt;  \
-		$(GO) test -coverprofile=coverage-tmp.txt $$p ; \
-		if [ -f coverage-tmp.txt ]; then \
-			cat coverage-tmp.txt |grep -v 'mode:' >> coverage.txt; \
-		fi; \
-	done
-	rm -f coverage-tmp.txt
+	$(GO) test -coverprofile=coverage-tmp.txt -coverpkg=github.com/mendersoftware/... ./...
+	if [ -f coverage-missing-subtests.txt ]; then \
+		echo 'mode: set' > coverage.txt; \
+		cat coverage-tmp.txt coverage-missing-subtests.txt | grep -v 'mode: set' >> coverage.txt; \
+	else \
+		mv coverage-tmp.txt coverage.txt; \
+	fi
+	rm -f coverage-tmp.txt coverage-missing-subtests.txt
 
 .PHONY: build clean get-tools test check \
-	cover htmlcover coverage
+	cover htmlcover coverage \
+	install install-bin install-conf install-datadir install-demo install-identity-scripts \
+	install-inventory-scripts install-modules install-modules-gen install-systemd \
+	uninstall uninstall-bin uninstall-conf uninstall-identity-scripts \
+	uninstall-inventory-scripts uninstall-modules uninstall-modules-gen uninstall-systemd

=== debian/changelog ===
mender-client (2.1.2-2) unstable; urgency=medium

  * Add debian/patches/0003-Update-tests-to-use-artifact-v2.patch
    - Fixes FTBFS with mender-artifact >= 3.2 (See #947135)

 -- Andreas Henriksson <andreas@fatal.se>  Sat, 21 Dec 2019 21:09:25 +0100

mender-client (2.1.2-1) unstable; urgency=medium

  * New upstream version 2.1.2

 -- Lluis Campos <lluis.campos@northern.tech>  Tue, 10 Dec 2019 14:52:13 +0100

mender-client (2.1.1-1) unstable; urgency=medium

  * New upstream version 2.1.1

 -- Lluis Campos <lluis.campos@northern.tech>  Mon, 14 Oct 2019 11:19:09 +0200

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
                golang-logrus-dev,
 	       golang-github-bmatsuo-lmdb-go-dev,
 	       golang-github-ungerik-go-sysfs-dev,
-	       golang-github-mendersoftware-mender-artifact-dev (>= 3.0.1),
+	       golang-github-mendersoftware-mender-artifact-dev (>= 3.1.0),
 	       golang-github-mendersoftware-log-dev,
 	       golang-github-mendersoftware-mendertesting-dev,
                ca-certificates <!nocheck>

=== debian/rules ===
--- 
+++ 
@@ -4,9 +4,9 @@
 
 export DH_GOLANG_INSTALL_EXTRA := client/server.crt \
 	client/server.expired.crt \
-	client/server.unknown-authority.crt
-#export DH_GOLANG_EXCLUDES := github.com/mendersoftware/mender$
-#export DH_GOLANG_EXCLUDES_ALL := 0
+	client/server.unknown-authority.crt \
+	installer/modules_test_helper.sh \
+	system/testing/os_calls_helper.sh
 
 override_dh_auto_install:
 	dh_auto_install -- --no-source

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/mender-client-\$1\.tar\.gz/,\
uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha|b)[.]?(\d*)$/\$1~\$2\$3/ \
  https://github.com/mendersoftware/mender/tags .*/v?(\d\S*)\.tar\.gz

## mender-client 2.2.0

=== debian/changelog ===
mender-client (2.2.0-4) unstable; urgency=medium

  * Add patches to switch to upstream sirupsen/logrus v1.5 (Closes: #955660)
  * Remove dependency golang-github-mendersoftware-mendertesting-dev
  * Remove depcreated dependency golang-github-mendersoftware-log-dev

 -- Lluis Campos <lluis.campos@northern.tech>  Mon, 20 Apr 2020 13:56:22 +0200

mender-client (2.2.0-3) unstable; urgency=medium

  * Add debian/patches/PR509.patch
    - should fix FTBFS on mips64el

 -- Andreas Henriksson <andreas@fatal.se>  Wed, 18 Mar 2020 22:39:30 +0100

mender-client (2.2.0-2) unstable; urgency=medium

  [ Andreas Henriksson ]
  * Add d/p/0004-Also-fix-app-test.go-pointer-to-map-confusion.patch

  [ Lluis Campos ]
  * Recreate d/p/0001-Skip-TestLicense to avoid mendertesting dependency
  * Add d/p/0005-Skip-test-TestBinarySize-N.A.-for-Debian-build.patch
  * Add d/p/0006-Fix-pointer-to-map-confusion-in-modules_test.go.patch
  * Add d/p/0007-Skip-TestMainExitCodes-test-it-fails-autopkgtest-on-.patch
  * Add d/p/0008-Generate-an-error... and d/p/0009-MEN-3277-Fix-check...
    - Fixes: CLI options -check-update and -send-inventory do not work (See #953635)
    - Fixes: Salsa CI autopkgtest aborts while running TestCheckUpdate unit test

 -- Lluis Campos <lluis.campos@northern.tech>  Sat, 14 Mar 2020 16:01:56 +0100

mender-client (2.2.0-1) unstable; urgency=medium

  * New upstream version 2.2.0
  * debian/rules: Use new variable name to inject version
  * Update Skip-TestLicense patch to apply again
  * Revert "Add debian/patches/0003-Update-tests-to-use-artifact-v2.patch"
  * Revert "Add debian/patches/0002-Use-UBI_IOCVOLUP-from[..].patch"
  * Add golang-golang-x-crypto-dev build-dependency
  * Add new build-dep for github.com/urfave/cli (v2) import
  * Add debian/patches/0002-Revert-switch-to-urfave-cli-v2-API.patch
  * Lower build-dep version of urfave/cli thanks to patch
  * Example mender.conf.* now lives in examples/
  * Bump debhelper from old 11 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Repository, Repository-Browse.
  * Add d/p/0003-Fix-pointer-to-map-which-is-a-pointer-confusion.patch

 -- Andreas Henriksson <andreas@fatal.se>  Mon, 09 Mar 2020 02:13:42 +0100

=== debian/control ===
--- 
+++ 
@@ -3,19 +3,19 @@
 Priority: optional
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Andreas Henriksson <andreas@fatal.se>, Lluis Campos <lluis.campos@northern.tech>
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 12),
                dh-golang,
                golang-any,
                golang-github-pkg-errors-dev,
                golang-github-stretchr-testify-dev,
+               golang-golang-x-crypto-dev,
                golang-golang-x-net-dev,
                golang-golang-x-sys-dev,
                golang-logrus-dev,
 	       golang-github-bmatsuo-lmdb-go-dev,
 	       golang-github-ungerik-go-sysfs-dev,
-	       golang-github-mendersoftware-mender-artifact-dev (>= 3.1.0),
-	       golang-github-mendersoftware-log-dev,
-	       golang-github-mendersoftware-mendertesting-dev,
+               golang-github-urfave-cli-dev,
+	       golang-github-mendersoftware-mender-artifact-dev (>= 3.3.0),
                ca-certificates <!nocheck>
 Standards-Version: 4.2.1
 Homepage: https://github.com/mendersoftware/mender

## mender-client 2.3.0

=== Makefile ===
--- 
+++ 
@@ -4,6 +4,7 @@
 datadir ?= /usr/share
 sysconfdir ?= /etc
 systemd_unitdir ?= /lib/systemd
+docexamplesdir ?= /usr/share/doc/mender-client/examples
 
 GO ?= go
 GOFMT ?= gofmt
@@ -11,21 +12,26 @@
 PKGS = $(shell go list ./... | grep -v vendor)
 PKGFILES = $(shell find . \( -path ./vendor -o -path ./Godeps \) -prune \
 		-o -type f -name '*.go' -print)
-PKGFILES_notest = $(shell echo $(PKGFILES) | tr ' ' '\n' | grep -v _test.go)
+PKGFILES_notest = $(shell echo $(PKGFILES) | tr ' ' '\n' | grep -v '\(client/test\|_test.go\)' )
 GOCYCLO ?= 15
 
 CGO_ENABLED=1
 export CGO_ENABLED
 
+# Get rid of useless warning in lmdb
+CGO_CFLAGS ?= -Wno-implicit-fallthrough
+export CGO_CFLAGS
+
 TOOLS = \
 	github.com/fzipp/gocyclo \
-	github.com/opennota/check/cmd/varcheck \
-	github.com/mendersoftware/deadcode
+	gitlab.com/opennota/check/cmd/varcheck \
+	github.com/mendersoftware/deadcode \
+	github.com/mendersoftware/gobinarycoverage
 
 VERSION = $(shell git describe --tags --dirty --exact-match 2>/dev/null || git rev-parse --short HEAD)
 
 GO_LDFLAGS = \
-	-ldflags "-X main.Version=$(VERSION)"
+	-ldflags "-X github.com/mendersoftware/mender/conf.Version=$(VERSION)"
 
 ifeq ($(V),1)
 BUILDV = -v
@@ -68,7 +74,7 @@
 mender: $(PKGFILES)
 	$(GO) build $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS)
 
-install: install-bin install-conf install-identity-scripts install-inventory-scripts install-modules install-systemd
+install: install-bin install-conf install-identity-scripts install-inventory-scripts install-modules install-systemd install-examples
 
 install-bin: mender
 	install -m 755 -d $(prefix)$(bindir)
@@ -76,9 +82,6 @@
 
 install-conf:
 	install -m 755 -d $(prefix)$(sysconfdir)/mender
-	install -m 644 mender.conf.production $(prefix)$(sysconfdir)/mender/mender.conf.production
-	install -m 644 mender.conf.production $(prefix)$(sysconfdir)/mender/mender.conf
-	install -m 644 mender.conf.demo $(prefix)$(sysconfdir)/mender/mender.conf.demo
 	echo "artifact_name=unknown" > $(prefix)$(sysconfdir)/mender/artifact_info
 
 install-datadir:
@@ -102,22 +105,20 @@
 
 install-systemd:
 	install -m 755 -d $(prefix)$(systemd_unitdir)/system
-	install -m 0644 support/mender.service $(prefix)$(systemd_unitdir)/system/
-
-install-demo: install
-	install -m 755 mender.conf.demo $(prefix)$(sysconfdir)/mender/mender.conf
+	install -m 0644 support/mender-client.service $(prefix)$(systemd_unitdir)/system/
+
+install-examples:
+	install -m 755 -d $(prefix)$(docexamplesdir)
+	install -m 0644 support/demo.crt $(prefix)$(docexamplesdir)/
 
 uninstall: uninstall-bin uninstall-conf uninstall-identity-scripts uninstall-inventory-scripts \
-	uninstall-modules uninstall-modules-gen uninstall-systemd
+	uninstall-modules uninstall-modules-gen uninstall-systemd uninstall-examples
 
 uninstall-bin:
 	rm -f $(prefix)$(bindir)/mender
 	-rmdir -p $(prefix)$(bindir)
 
 uninstall-conf:
-	rm -f $(prefix)$(sysconfdir)/mender/mender.conf
-	rm -f $(prefix)$(sysconfdir)/mender/mender.conf.production
-	rm -f $(prefix)$(sysconfdir)/mender/mender.conf.demo
 	rm -f $(prefix)$(sysconfdir)/mender/artifact_info
 	-rmdir -p $(prefix)$(sysconfdir)/mender
 
@@ -146,8 +147,12 @@
 	-rmdir -p $(prefix)$(bindir)
 
 uninstall-systemd:
-	rm -f $(prefix)$(systemd_unitdir)/system/mender.service
+	rm -f $(prefix)$(systemd_unitdir)/system/mender-client.service
 	-rmdir -p $(prefix)$(systemd_unitdir)/system
+
+uninstall-examples:
+	rm -f $(prefix)$(docexamplesdir)/demo.crt
+	-rmdir -p $(prefix)$(docexamplesdir)
 
 clean:
 	$(GO) clean
@@ -164,19 +169,30 @@
 test:
 	$(GO) test $(BUILDV) $(PKGS)
 
-extracheck:
+extracheck: gofmt govet godeadcode govarcheck gocyclo
+	echo "All extra-checks passed!"
+
+gofmt:
 	echo "-- checking if code is gofmt'ed"
 	if [ -n "$$($(GOFMT) -d $(PKGFILES))" ]; then \
 		"$$($(GOFMT) -d $(PKGFILES))" \
 		echo "-- gofmt check failed"; \
 		/bin/false; \
 	fi
+
+govet:
 	echo "-- checking with govet"
-	$(GO) tool vet -unsafeptr=false $(PKGFILES_notest)
+	$(GO) vet -unsafeptr=false
+
+godeadcode:
 	echo "-- checking for dead code"
 	deadcode -ignore version.go:Version
+
+govarcheck:
 	echo "-- checking with varcheck"
-	varcheck .
+	varcheck ./...
+
+gocyclo:
 	echo "-- checking cyclometric complexity > $(GOCYCLO)"
 	gocyclo -over $(GOCYCLO) $(PKGFILES_notest)
 
@@ -197,9 +213,37 @@
 	fi
 	rm -f coverage-tmp.txt coverage-missing-subtests.txt
 
-.PHONY: build clean get-tools test check \
-	cover htmlcover coverage \
-	install install-bin install-conf install-datadir install-demo install-identity-scripts \
-	install-inventory-scripts install-modules install-modules-gen install-systemd \
-	uninstall uninstall-bin uninstall-conf uninstall-identity-scripts \
-	uninstall-inventory-scripts uninstall-modules uninstall-modules-gen uninstall-systemd
+instrument-binary:
+	# Patch the client to make it ready for coverage analysis
+	git apply patches/0001-Instrument-Mender-client-for-coverage-analysis.patch
+	# Then instrument the files with the gobinarycoverage tool
+	gobinarycoverage github.com/mendersoftware/mender
+
+.PHONY: build
+.PHONY: clean
+.PHONY: get-tools
+.PHONY: test
+.PHONY: check
+.PHONY: cover
+.PHONY: htmlcover
+.PHONY: coverage
+.PHONY: install
+.PHONY: install-bin
+.PHONY: install-conf
+.PHONY: install-datadir
+.PHONY: install-identity-scripts
+.PHONY: install-inventory-scripts
+.PHONY: install-modules
+.PHONY: install-modules-gen
+.PHONY: install-systemd
+.PHONY: install-examples
+.PHONY: uninstall
+.PHONY: uninstall-bin
+.PHONY: uninstall-conf
+.PHONY: uninstall-identity-scripts
+.PHONY: uninstall-inventory-scripts
+.PHONY: uninstall-modules
+.PHONY: uninstall-modules-gen
+.PHONY: uninstall-systemd
+.PHONY: uninstall-examples
+.PHONY: instrument-binary

=== debian/changelog ===
mender-client (2.3.0-1build1) hirsute; urgency=medium

  * No-change rebuild using new golang

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 11 Nov 2020 22:19:33 +0000

mender-client (2.3.0-1) unstable; urgency=medium

  * New upstream version 2.3.0
  * Revert "Add patches to switch to upstream sirupsen/logrus v1.5"
  * Revert "Add debian/patches/PR509.patch"
  * Revert "Add d/p/0008-Generate-an-error... and d/p/0009-MEN-3277-Fix-check..."
  * Revert "Add d/p/0006-Fix-pointer-to-map-confusion-in-modules_test.go.patch"
  * Revert "Add d/p/0004-Also-fix-app-test.go-pointer-to-map-confusion.patch"
  * Revert "Add d/p/0003-Fix-pointer-to-map-which-is-a-pointer-confusion.patch"
  * Update Skip TestLicense and Revert urfave cli v2 patches to apply
  * Bump mender-artifact build-dep to >= 3.4.0

 -- Andreas Henriksson <andreas@fatal.se>  Mon, 27 Jul 2020 13:28:43 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: mender-client
 Section: devel
 Priority: optional
-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Andreas Henriksson <andreas@fatal.se>, Lluis Campos <lluis.campos@northern.tech>
 Build-Depends: debhelper-compat (= 12),
                dh-golang,
@@ -15,7 +16,7 @@
 	       golang-github-bmatsuo-lmdb-go-dev,
 	       golang-github-ungerik-go-sysfs-dev,
                golang-github-urfave-cli-dev,
-	       golang-github-mendersoftware-mender-artifact-dev (>= 3.3.0),
+	       golang-github-mendersoftware-mender-artifact-dev (>= 3.4.0),
                ca-certificates <!nocheck>
 Standards-Version: 4.2.1
 Homepage: https://github.com/mendersoftware/mender

## mender-client 2.4.1

=== Makefile ===
--- 
+++ 
@@ -23,7 +23,7 @@
 export CGO_CFLAGS
 
 TOOLS = \
-	github.com/fzipp/gocyclo \
+	github.com/fzipp/gocyclo/... \
 	gitlab.com/opennota/check/cmd/varcheck \
 	github.com/mendersoftware/deadcode \
 	github.com/mendersoftware/gobinarycoverage
@@ -54,7 +54,8 @@
 	support/mender-inventory-hostinfo \
 	support/mender-inventory-network \
 	support/mender-inventory-os \
-	support/mender-inventory-rootfs-type
+	support/mender-inventory-rootfs-type \
+	support/mender-inventory-geo
 
 MODULES = \
 	support/modules/deb \
@@ -161,7 +162,7 @@
 get-tools:
 	set -e ; for t in $(TOOLS); do \
 		echo "-- go getting $$t"; \
-		go get -u $$t; \
+		GO111MODULE=off go get -u $$t; \
 	done
 
 check: test extracheck
@@ -204,7 +205,7 @@
 
 coverage:
 	rm -f coverage.txt
-	$(GO) test -coverprofile=coverage-tmp.txt -coverpkg=github.com/mendersoftware/... ./...
+	$(GO) test -coverprofile=coverage-tmp.txt -coverpkg=./... ./...
 	if [ -f coverage-missing-subtests.txt ]; then \
 		echo 'mode: set' > coverage.txt; \
 		cat coverage-tmp.txt coverage-missing-subtests.txt | grep -v 'mode: set' >> coverage.txt; \

=== debian/changelog ===
mender-client (2.4.1-2) unstable; urgency=medium

  * Recommend libubootenv-tool instead of u-boot-tools

 -- Andreas Henriksson <andreas@fatal.se>  Tue, 13 Apr 2021 21:20:55 +0200

mender-client (2.4.1-1) unstable; urgency=medium

  * New upstream version 2.4.1
  * Add new build dependencies pkg-config, golang-github-mendersoftware-openssl-dev
  * Refresh existing d/patches
  * Add d/p/0005-Revert-import-github.com-urfave-cli-v2-to-github.com.patch

 -- Lluis Campos <lluis.campos@northern.tech>  Mon, 23 Nov 2020 10:28:52 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,11 @@
 Source: mender-client
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
+Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Andreas Henriksson <andreas@fatal.se>, Lluis Campos <lluis.campos@northern.tech>
 Build-Depends: debhelper-compat (= 12),
                dh-golang,
+               pkg-config,
                golang-any,
                golang-github-pkg-errors-dev,
                golang-github-stretchr-testify-dev,
@@ -13,10 +13,11 @@
                golang-golang-x-net-dev,
                golang-golang-x-sys-dev,
                golang-logrus-dev,
-	       golang-github-bmatsuo-lmdb-go-dev,
-	       golang-github-ungerik-go-sysfs-dev,
+               golang-github-bmatsuo-lmdb-go-dev,
+               golang-github-ungerik-go-sysfs-dev,
                golang-github-urfave-cli-dev,
-	       golang-github-mendersoftware-mender-artifact-dev (>= 3.4.0),
+               golang-github-mendersoftware-mender-artifact-dev (>= 3.4.0),
+               golang-github-mendersoftware-openssl-dev (>=0.0.10),
                ca-certificates <!nocheck>
 Standards-Version: 4.2.1
 Homepage: https://github.com/mendersoftware/mender
@@ -30,7 +31,11 @@
 Built-Using: ${misc:Built-Using}
 Depends: ${misc:Depends},
          ${shlibs:Depends}
-Recommends: ca-certificates, u-boot-tools, mount, procps, systemd-sysv
+Recommends: ca-certificates,
+            libubootenv-tool (>= 0.3-3~) | u-boot-tools (<< 2019.10~rc4+dfsg-1~),
+	    mount,
+	    procps,
+	    systemd-sysv
 Description: Mender over-the-air software updater client.
  Mender: over-the-air updater for embedded Linux devices
  .

=== debian/rules ===
--- 
+++ 
@@ -16,7 +16,7 @@
 
 override_dh_auto_build:
 	dh_auto_build -O--buildsystem=golang -- \
-		-ldflags "-X main.Version=$(DEB_VERSION)"
+		-ldflags "-X github.com/mendersoftware/mender/conf.Version=$(DEB_VERSION)"
 
 override_dh_auto_test:
 	dh_auto_test || true

## mender-client 3.0.0+ds1

=== Makefile ===
--- 
+++ 
@@ -19,7 +19,7 @@
 export CGO_ENABLED
 
 # Get rid of useless warning in lmdb
-CGO_CFLAGS ?= -Wno-implicit-fallthrough
+CGO_CFLAGS ?= -Wno-implicit-fallthrough -Wno-stringop-overflow
 export CGO_CFLAGS
 
 TOOLS = \
@@ -54,7 +54,11 @@
 	support/mender-inventory-hostinfo \
 	support/mender-inventory-network \
 	support/mender-inventory-os \
+	support/mender-inventory-provides \
 	support/mender-inventory-rootfs-type \
+	support/mender-inventory-update-modules
+
+INVENTORY_NETWORK_SCRIPTS = \
 	support/mender-inventory-geo
 
 MODULES = \
@@ -70,12 +74,23 @@
 	support/modules-artifact-gen/directory-artifact-gen \
 	support/modules-artifact-gen/single-file-artifact-gen
 
-build: mender
-
-mender: $(PKGFILES)
+DBUS_POLICY_FILES = \
+	support/dbus/io.mender.AuthenticationManager.conf \
+	support/dbus/io.mender.UpdateManager.conf
+
+build:
 	$(GO) build $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS)
 
-install: install-bin install-conf install-identity-scripts install-inventory-scripts install-modules install-systemd install-examples
+mender: build
+
+install: install-bin \
+	install-conf \
+	install-dbus \
+	install-examples \
+	install-identity-scripts \
+	install-inventory-scripts \
+	install-modules \
+	install-systemd
 
 install-bin: mender
 	install -m 755 -d $(prefix)$(bindir)
@@ -88,13 +103,23 @@
 install-datadir:
 	install -m 755 -d $(prefix)$(datadir)/mender
 
+install-dbus: install-datadir
+	install -m 755 -d $(prefix)$(datadir)/dbus-1/system.d
+	install -m 644 $(DBUS_POLICY_FILES) $(prefix)$(datadir)/dbus-1/system.d/
+
 install-identity-scripts: install-datadir
 	install -m 755 -d $(prefix)$(datadir)/mender/identity
 	install -m 755 $(IDENTITY_SCRIPTS) $(prefix)$(datadir)/mender/identity/
 
-install-inventory-scripts: install-datadir
+install-inventory-scripts: install-inventory-local-scripts install-inventory-network-scripts
+
+install-inventory-local-scripts: install-datadir
 	install -m 755 -d $(prefix)$(datadir)/mender/inventory
 	install -m 755 $(INVENTORY_SCRIPTS) $(prefix)$(datadir)/mender/inventory/
+
+install-inventory-network-scripts: install-datadir
+	install -m 755 -d $(prefix)$(datadir)/mender/inventory
+	install -m 755 $(INVENTORY_NETWORK_SCRIPTS) $(prefix)$(datadir)/mender/inventory/
 
 install-modules:
 	install -m 755 -d $(prefix)$(datadir)/mender/modules/v3
@@ -112,8 +137,15 @@
 	install -m 755 -d $(prefix)$(docexamplesdir)
 	install -m 0644 support/demo.crt $(prefix)$(docexamplesdir)/
 
-uninstall: uninstall-bin uninstall-conf uninstall-identity-scripts uninstall-inventory-scripts \
-	uninstall-modules uninstall-modules-gen uninstall-systemd uninstall-examples
+uninstall: uninstall-bin \
+	uninstall-conf \
+	uninstall-dbus \
+	uninstall-identity-scripts \
+	uninstall-inventory-scripts \
+	uninstall-modules \
+	uninstall-modules-gen \
+	uninstall-systemd \
+	uninstall-examples
 
 uninstall-bin:
 	rm -f $(prefix)$(bindir)/mender
@@ -123,14 +155,29 @@
 	rm -f $(prefix)$(sysconfdir)/mender/artifact_info
 	-rmdir -p $(prefix)$(sysconfdir)/mender
 
+uninstall-dbus:
+	for policy in $(DBUS_POLICY_FILES); do \
+		rm -f $(prefix)$(datadir)/dbus-1/system.d/$$(basename $$policy); \
+	done
+	-rmdir -p $(prefix)$(datadir)/dbus-1/system.d
+
 uninstall-identity-scripts:
 	for script in $(IDENTITY_SCRIPTS); do \
 		rm -f $(prefix)$(datadir)/mender/identity/$$(basename $$script); \
 	done
 	-rmdir -p $(prefix)$(datadir)/mender/identity
 
-uninstall-inventory-scripts:
+uninstall-inventory-scripts: uninstall-inventory-local-scripts uninstall-inventory-network-scripts
+	-rmdir -p $(prefix)$(datadir)/mender/inventory
+
+uninstall-inventory-local-scripts:
 	for script in $(INVENTORY_SCRIPTS); do \
+		rm -f $(prefix)$(datadir)/mender/inventory/$$(basename $$script); \
+	done
+	-rmdir -p $(prefix)$(datadir)/mender/inventory
+
+uninstall-inventory-network-scripts:
+	for script in $(INVENTORY_NETWORK_SCRIPTS); do \
 		rm -f $(prefix)$(datadir)/mender/inventory/$$(basename $$script); \
 	done
 	-rmdir -p $(prefix)$(datadir)/mender/inventory
@@ -232,8 +279,11 @@
 .PHONY: install-bin
 .PHONY: install-conf
 .PHONY: install-datadir
+.PHONY: install-dbus
 .PHONY: install-identity-scripts
 .PHONY: install-inventory-scripts
+.PHONY: install-inventory-local-scripts
+.PHONY: install-inventory-network-scripts
 .PHONY: install-modules
 .PHONY: install-modules-gen
 .PHONY: install-systemd
@@ -241,8 +291,11 @@
 .PHONY: uninstall
 .PHONY: uninstall-bin
 .PHONY: uninstall-conf
+.PHONY: uninstall-dbus
 .PHONY: uninstall-identity-scripts
 .PHONY: uninstall-inventory-scripts
+.PHONY: uninstall-inventory-local-scripts
+.PHONY: uninstall-inventory-network-scripts
 .PHONY: uninstall-modules
 .PHONY: uninstall-modules-gen
 .PHONY: uninstall-systemd

=== support/modules-artifact-gen/tests/requirements.txt ===
attrs==20.3.0
iniconfig==1.1.1
packaging==20.9
pluggy==0.13.1
py==1.10.0
pyparsing==2.4.7
pytest==6.2.3
toml==0.10.2

=== debian/changelog ===
mender-client (3.0.0+ds1-2) unstable; urgency=medium

  * Build-dep on dbus-daemon for tests
  * Install dummy certificates for tests
  * Install extra cert keys for testing
  * Release to unstable.

 -- Andreas Henriksson <andreas@fatal.se>  Wed, 19 Jan 2022 12:46:15 +0100

mender-client (3.0.0+ds1-1) experimental; urgency=medium

  * debian/watch: dversionmangle to use +ds suffix for mangled orig tarballs
  * New upstream release.
  * Add mender/progressbar build-dep
  * Drop d/p/0001-Skip-TestLicense-for-Debian-Unit-Test-suite.patch
    - no longer needed. Test dropped upstream.
  * Change build-dep to urfave/v2 and drop revert patches
  * Bump required version of mender-artifact build-dep
  * Build-dep on libglib2.0-dev for gio-2.0 (dbus)
  * Also build-dep on godbus for tests

 -- Andreas Henriksson <andreas@fatal.se>  Sun, 07 Nov 2021 12:56:59 +0100

=== debian/control ===
--- 
+++ 
@@ -15,9 +15,13 @@
                golang-logrus-dev,
                golang-github-bmatsuo-lmdb-go-dev,
                golang-github-ungerik-go-sysfs-dev,
-               golang-github-urfave-cli-dev,
-               golang-github-mendersoftware-mender-artifact-dev (>= 3.4.0),
+               golang-github-urfave-cli-v2-dev,
+               golang-github-mendersoftware-mender-artifact-dev (>= 3.5.0),
                golang-github-mendersoftware-openssl-dev (>=0.0.10),
+               golang-github-mendersoftware-progressbar-dev (>= 0.0.3),
+	       libglib2.0-dev,
+               dbus-daemon <!nocheck>,
+	       golang-dbus-dev <!nocheck>,
                ca-certificates <!nocheck>
 Standards-Version: 4.2.1
 Homepage: https://github.com/mendersoftware/mender

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%mender-client-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha|b)[.]?(\d*)$/\$1~\$2\$3/,\
      dversionmangle=s/\+ds\d*$//,repacksuffix=+ds1" \
  https://github.com/mendersoftware/mender/tags .*/v?(\d\S*)\.tar\.gz debian

## mender-client 3.4.0%2Bds1

=== debian/changelog ===
mender-client (3.4.0+ds1-5ubuntu0.24.10.1) oracular-security; urgency=medium

  * No change rebuild due to golang-1.22 update

 -- Evan Caville <evan.caville@canonical.com>  Fri, 27 Jun 2025 11:54:44 +1000

mender-client (3.4.0+ds1-5build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:52:16 +1100

mender-client (3.4.0+ds1-5build2) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 19:59:40 +0000

mender-client (3.4.0+ds1-5build1) mantic; urgency=medium

  * No-change rebuild with Go 1.21.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 24 Aug 2023 17:16:47 +1200

mender-client (3.4.0+ds1-5) unstable; urgency=medium

  * mender-client.service: Avoid double log messages

 -- Andreas Henriksson <andreas@fatal.se>  Sat, 18 Feb 2023 20:31:56 +0100

mender-client (3.4.0+ds1-4) unstable; urgency=medium

  [ Matthias Lüscher ]
  * Install dbus configuration files to enable mender-connect.
  * Added dbus as a recommended dependency.

 -- Andreas Henriksson <andreas@fatal.se>  Fri, 13 Jan 2023 14:11:18 +0100

mender-client (3.4.0+ds1-3) unstable; urgency=medium

  [ Matthias Lüscher ]
  * Fix the mender client startup.

 -- Andreas Henriksson <andreas@fatal.se>  Fri, 02 Dec 2022 15:09:50 +0100

mender-client (3.4.0+ds1-2) unstable; urgency=medium

  * Install update module artifact generators as examples
  * Install upstream provided update modules scripts

 -- Andreas Henriksson <andreas@fatal.se>  Mon, 24 Oct 2022 18:51:21 +0200

mender-client (3.4.0+ds1-1) unstable; urgency=medium

  * New upstream version 3.4.0+ds1
  * Bump mender-artifact build-dep because of API breakage
  * Bump debhelper from old 12 to 13.
  * Fix up debian/control whitespace

 -- Andreas Henriksson <andreas@fatal.se>  Fri, 14 Oct 2022 15:06:19 +0200

mender-client (3.3.0+ds1-2) unstable; urgency=medium

  * Release to unstable.

 -- Andreas Henriksson <andreas@fatal.se>  Mon, 10 Oct 2022 18:04:53 +0200

mender-client (3.3.0+ds1-1) experimental; urgency=medium

  * debian/watch: let uversionmangle strip -build from tags
  * New upstream release.
  * Build-dep on procps for process leaking tests
  * Add debian/patches/bump-leak-process-test-timeout.patch

 -- Andreas Henriksson <andreas@fatal.se>  Sat, 11 Jun 2022 00:29:47 +0200

mender-client (3.2.1+ds1-1) experimental; urgency=medium

  * New upstream version 3.2.1+ds1
  * Build-dep on gorilla-websocket >= 1.5.0
  * Bump mender-artifact build-dep to >= 3.7.0

 -- Andreas Henriksson <andreas@fatal.se>  Sat, 19 Mar 2022 11:05:00 +0100

## mender-client 3.4.0+ds1

=== Makefile ===
--- 
+++ 
@@ -26,7 +26,8 @@
 	github.com/fzipp/gocyclo/... \
 	gitlab.com/opennota/check/cmd/varcheck \
 	github.com/mendersoftware/deadcode \
-	github.com/mendersoftware/gobinarycoverage
+	github.com/mendersoftware/gobinarycoverage \
+	github.com/jstemmer/go-junit-report
 
 VERSION = $(shell git describe --tags --dirty --exact-match 2>/dev/null || git rev-parse --short HEAD)
 
@@ -78,10 +79,10 @@
 	support/dbus/io.mender.AuthenticationManager.conf \
 	support/dbus/io.mender.UpdateManager.conf
 
-build:
+build: mender
+
+mender: $(PKGFILES)
 	$(GO) build $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS)
-
-mender: build
 
 install: install-bin \
 	install-conf \
@@ -230,7 +231,7 @@
 
 govet:
 	echo "-- checking with govet"
-	$(GO) vet -unsafeptr=false
+	$(GO) vet -composites=false -unsafeptr=false ./...
 
 godeadcode:
 	echo "-- checking for dead code"
@@ -252,7 +253,10 @@
 
 coverage:
 	rm -f coverage.txt
-	$(GO) test -coverprofile=coverage-tmp.txt -coverpkg=./... ./...
+	$(GO) test -v -coverprofile=coverage-tmp.txt -coverpkg=./... ./... > .tmp.go-test.txt ; echo $$? > .tmp.return-code.txt
+	cat .tmp.go-test.txt
+	go-junit-report < .tmp.go-test.txt > report.xml
+	rm -f .tmp.go-test.txt
 	if [ -f coverage-missing-subtests.txt ]; then \
 		echo 'mode: set' > coverage.txt; \
 		cat coverage-tmp.txt coverage-missing-subtests.txt | grep -v 'mode: set' >> coverage.txt; \
@@ -260,6 +264,11 @@
 		mv coverage-tmp.txt coverage.txt; \
 	fi
 	rm -f coverage-tmp.txt coverage-missing-subtests.txt
+	failing_tests=$$(grep -Po '(?<=failures=")\d+' report.xml | awk '{s+=$$1} END {print s}'); \
+	echo FAILING TESTS: $$failing_tests
+	return_code=$$(cat .tmp.return-code.txt); \
+	rm -f .tmp.return-code.txt; \
+	exit $$return_code
 
 instrument-binary:
 	# Patch the client to make it ready for coverage analysis

=== debian/changelog ===
mender-client (3.4.0+ds1-5ubuntu0.24.04.3) noble-security; urgency=medium

  * No change rebuild due to golang-1.22 update

 -- Evan Caville <evan.caville@canonical.com>  Wed, 25 Jun 2025 14:16:37 +1000

mender-client (3.4.0+ds1-5ubuntu0.24.04.2) noble-security; urgency=medium

  * No change rebuild due to golang-1.22 update

 -- Evan Caville <evan.caville@canonical.com>  Wed, 06 Nov 2024 15:08:27 +1000

mender-client (3.4.0+ds1-5ubuntu0.24.04.1) noble-security; urgency=medium

  * No change rebuild due to golang-1.22 update

 -- Nishit Majithia <nishit.majithia@canonical.com>  Tue, 16 Jul 2024 11:23:10 +0530

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: mender-client
 Section: devel
 Priority: optional
-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Andreas Henriksson <andreas@fatal.se>, Lluis Campos <lluis.campos@northern.tech>
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                dh-golang,
                pkg-config,
                golang-any,
@@ -14,14 +15,16 @@
                golang-golang-x-sys-dev,
                golang-logrus-dev,
                golang-github-bmatsuo-lmdb-go-dev,
+               golang-github-gorilla-websocket-dev (>= 1.5.0~),
                golang-github-ungerik-go-sysfs-dev,
                golang-github-urfave-cli-v2-dev,
-               golang-github-mendersoftware-mender-artifact-dev (>= 3.5.0),
-               golang-github-mendersoftware-openssl-dev (>=0.0.10),
+               golang-github-mendersoftware-mender-artifact-dev (>= 3.9.0),
+               golang-github-mendersoftware-openssl-dev (>= 0.0.10),
                golang-github-mendersoftware-progressbar-dev (>= 0.0.3),
-	       libglib2.0-dev,
+               libglib2.0-dev,
+               procps <!nocheck>,
                dbus-daemon <!nocheck>,
-	       golang-dbus-dev <!nocheck>,
+               golang-dbus-dev <!nocheck>,
                ca-certificates <!nocheck>
 Standards-Version: 4.2.1
 Homepage: https://github.com/mendersoftware/mender
@@ -36,10 +39,11 @@
 Depends: ${misc:Depends},
          ${shlibs:Depends}
 Recommends: ca-certificates,
+            default-dbus-system-bus | dbus-system-bus,
             libubootenv-tool (>= 0.3-3~) | u-boot-tools (<< 2019.10~rc4+dfsg-1~),
-	    mount,
-	    procps,
-	    systemd-sysv
+            mount,
+            procps,
+            systemd-sysv
 Description: Mender over-the-air software updater client.
  Mender: over-the-air updater for embedded Linux devices
  .
